package com.zhili.netty;

import com.zhili.netty.NettyClient.NettyTcpClient;
import com.zhili.netty.Nettyserver.NettyTcpServer;
import io.netty.channel.ChannelFuture;
import lombok.Value;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import springfox.documentation.oas.annotations.EnableOpenApi;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

/**
 * @author user
 */
@EnableSwagger2
@EnableOpenApi
@SpringBootApplication
@MapperScan(basePackages = "com.**.mapper")
@EnableAsync
@EnableCaching
@EnableTransactionManagement
@EnableScheduling
public class NettyDemoApplication implements CommandLineRunner {
    public static void main(String[] args) {
        SpringApplication.run(NettyDemoApplication.class, args);
    }

    @Autowired
    NettyTcpServer nettyTcpServer;

    @Autowired
    NettyTcpClient nettyTcpClient;

    /**
     * Callback used to run the bean.
     *
     * @param args incoming main method arguments
     * @throws Exception on error
     */
    @Override
    public void run(String... args) throws Exception {
        ChannelFuture start = nettyTcpServer.start();
        nettyTcpClient.connect();
        //for (int i = 0; i < 10; i++) {
        //    nettyTcpClient.sendMessage("hello world "+i);
        //}
        start.channel().closeFuture().syncUninterruptibly();
    }
}
