package com.zhili.netty.controller;

import com.alibaba.fastjson.JSON;
import com.zhili.netty.NettyClient.NettyTcpClient;
import com.zhili.netty.base.AjaxResult;
import com.zhili.netty.entity.NettyMessage;
import com.zhili.netty.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author zyg
 * @className MessageController
 * @date 2022年07月21日 14:54
 */
@RestController
@Api(tags = "发送消息给服务器接口")
@RequestMapping("/business/message")
public class MessageController {

    @Autowired
    NettyTcpClient client;

    @PostMapping("/send")
    @ApiOperation("发送消息给服务器")
    public AjaxResult sendMessage(@RequestBody NettyMessage message) throws InterruptedException {
        client.connect();
        client.sendMessage(JSON.toJSONString(message));
        return new AjaxResult();
    }

}
